<template>
<div class="view-container dewfdynaactionview ibizsample0021-addstepbeforewfdyna-action-view">
    <card class='view-card view-no-caption view-no-toolbar' :disHover="true" :padding="0" :bordered="false">
    <div class="content-container">
    <component 
        :is="activeForm.name"
        :viewState="viewState"  
        :viewparams="viewparams" 
        :context="context" 
        :autosave="false" 
        :viewtag="viewtag"
        :showBusyIndicator="activeForm.showBusyIndicator"
        :updateAction="activeForm.updateAction"
        :removeAction="activeForm.removeAction"
        :loaddraftAction="activeForm.loaddraftAction"
        :loadAction="activeForm.loadAction"
        :createAction="activeForm.createAction"
        :WFSubmitAction="activeForm.WFSubmitAction"
        :WFStartAction="activeForm.WFStartAction"
        name="form"  
        ref='form'>
    </component>
    </div>
    <card dis-hover :bordered="false" class='footer'>
        <row style=" text-align: right ">
        <i-button type='primary' @click="onClickOk">{{ $t("app.commonWords.ok") }}</i-button>
            &nbsp;&nbsp;
        <i-button @click="onClickCancel">{{ $t("app.commonWords.cancel") }}</i-button>
        </row>
    </card>
    </card>
</div>
</template>
// 基于 @VIEW/实体工作流动态操作视图/VIEW-BASE.vue.ftl 生成

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util } from '@/utils';
import axios from 'axios';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
import { Subject,Subscription } from 'rxjs';
import IBIZSample0021Service from '@/service/ibizsample0021/ibizsample0021-service';
import IBIZSample0021AuthService from '@/authservice/ibizsample0021/ibizsample0021-auth-service';


import IBIZSample0021UIService from '@/uiservice/ibizsample0021/ibizsample0021-ui-service';


@Component({
    components: {
    },
})
export default class IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase extends Vue {

    /**
     * 实体服务对象
     *
     * @type {IBIZSample0021Service}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public appEntityService: IBIZSample0021Service = new IBIZSample0021Service();

    /**
     * 实体UI服务对象
     *
     * @type IBIZSample0021UIService
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public appUIService: IBIZSample0021UIService = new IBIZSample0021UIService();
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
	 */
	public viewtag: string = 'FE8FC98E-6465-4EB3-9336-BE1E90897170';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
	 */
	public viewType: string = 'DEWFDYNAACTIONVIEW';

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
	 */
    public customViewNavContexts:any ={
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
	 */
    public customViewParams:any ={
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public model: any = {
        srfCaption: 'entities.ibizsample0021.views.addstepbeforewfdynaactionview.caption',
        srfTitle: 'entities.ibizsample0021.views.addstepbeforewfdynaactionview.title',
        srfSubTitle: 'entities.ibizsample0021.views.addstepbeforewfdynaactionview.subtitle',
        dataInfo: ''
    }

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if(newVal){
            this.viewparams = {};
            if(typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            }else{
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            if(this.viewparams && this.viewparams.actionForm){
                this.computeActivedForm(this.viewparams.actionForm);
            }else{
                this.computeActivedForm(null);
            }

        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        
        if (!Object.is(newVal, oldVal) && _this.engine) {
            this.$nextTick(()=>{
              _this.parseViewParam();
              _this.engine.load();
            });
        } else if(!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public containerModel: any = {
        view_wfform_beforesign: { name: 'wfform_beforesign', type: 'FORM' },
        view_wfform_main: { name: 'wfform_main', type: 'FORM' },
        view_form: { name: 'form', type: 'FORM' },
        wflinks: [],
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public viewCtx: any = {};

    /**
     * 视图刷新
     *
     * @param {*} args
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public refresh(args?: any): void {
        const refs: any = this.$refs;
        if (refs && refs.form) {
            refs.form.refresh();
        }
    }
    /**
     *  计数器刷新
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public viewState: Subject<ViewState> = new Subject();



    /**
     * 引擎初始化
     *
     * @public
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public engineInit(): void {
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public  navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    @Prop() public portletState?: any;

    /**
     * 门户部件状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public portletStateEvent: Subscription | undefined;

    /**
    * 门户部件状态事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
    */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public viewCacheData:any;


    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 解析视图参数
     *
     * @public
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public parseViewParam(inputvalue:any = null): void {
        for(let key in this.context){
            delete this.context[key];
        }
        if(this.$store.getters.getAppData() && this.$store.getters.getAppData().context){
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        if(inputvalue){
            Object.assign(this.context,{'ibizsample0021':inputvalue});
        }
        //初始化视图唯一标识
        Object.assign(this.context,{srfsessionid:this.$util.createUUID()});
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
	public handleCustomViewData(){
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'ibizsample0021-addstepbeforewfdyna-action-view',tag:this.viewtag,srfkey:isNew ? null : this.context.ibizsample0021,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'ibizsample0021-addstepbeforewfdyna-action-view',tag:this.viewtag,srfkey:this.context.ibizsample0021,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	

    /**
     * Vue声明周期
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'ibizsample0021-addstepbeforewfdyna-action-view')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    if(_this.engine){
                        _this.engine.load();
                    }
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'IBIZSample0021ADDSTEPBEFOREWFDynaActionView')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.formDruipartEvent) {
            _this.formDruipartEvent.unsubscribe();
        }
        if (_this.engine) {
            _this.engine.destroy();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public afterMounted(){
        const _this: any = this;
        _this.engineInit();
            if (_this.loadModel && _this.loadModel instanceof Function) {
                _this.loadModel();
            }
            this.viewState.next({ tag: "form", action: "autoload", data: {srfkey:this.context.ibizsample0021} });
    }




    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        }else{
            _view.$router.back();
        }
    }

    /**
     * 销毁视图回调
     *
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public destroyed(){
        this.afterDestroyed();
    }

    /**
     * 执行destroyed后的逻辑
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public afterDestroyed(){
        if (this.viewDefaultUsage) {
                let localStoreLength = Object.keys(localStorage);
                if(localStoreLength.length > 0){
                    localStoreLength.forEach((item:string) =>{
                    if(item.startsWith(this.context.srfsessionid)){
                        localStorage.removeItem(item);
                    }
                    })
                }
                if(Object.is(this.navModel,"tab")){
                    this.navDataService.removeNavDataByTag(this.viewtag);
                }
            }
            // 销毁计数器定时器
            if(this.counterServiceArray && this.counterServiceArray.length >0){
                this.counterServiceArray.forEach((item:any) =>{
                    if(item.destroyCounter && item.destroyCounter instanceof Function){
                        item.destroyCounter();
                    }
                })
            }
    }
    
    /**
     * 当前激活表单
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public activeForm:any = {};

    /**
     * 所有表单
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    /**
     * 所有表单数据
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public allForm: any = {
        "wfform_beforesign":{name:"view_wfform_beforesign",autosave:"false",showBusyIndicator:"true",updateAction:"Update",removeAction:"Remove",loaddraftAction:"GetDraft",loadAction:"Get",createAction:"Create",WFSubmitAction:"",WFStartAction:""},
        "wfform_main":{name:"view_wfform_main",autosave:"false",showBusyIndicator:"true",updateAction:"Update",removeAction:"Remove",loaddraftAction:"GetDraft",loadAction:"Get",createAction:"Create",WFSubmitAction:"",WFStartAction:""},
        "form":{name:"view_form",autosave:"false",showBusyIndicator:"true",updateAction:"Update",removeAction:"Remove",loaddraftAction:"GetDraft",loadAction:"Get",createAction:"Create",WFSubmitAction:"",WFStartAction:""}
    };

    /**
     * 计算激活表单
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public computeActivedForm(inputForm:any){
        if(!inputForm){
            this.activeForm = this.allForm && Object.values(this.allForm)[0];
            return;
        }
        if(this.allForm && Object.keys(this.allForm).length >0){
            Object.keys(this.allForm).forEach((name:string) =>{
                if(Object.is(name,`wfform_${inputForm.toLowerCase()}`)){
                    this.activeForm = this.allForm[name];
                }
            })
        }
    }

    /**
     * 确认
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public onClickOk(){
        let xData:any = this.$refs.form;
        if(xData){
            let preFormData:any = xData.getData();
            let nextFormData:any = xData.transformData(preFormData);
            Object.assign(preFormData,nextFormData);
            this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
            this.$emit('viewdataschange', [preFormData]);
            this.$emit('close', null);
        }
    }

    /**
     * 取消
     * 
     * @memberof IBIZSample0021ADDSTEPBEFOREWFDynaActionViewBase
     */
    public onClickCancel(){
        this.$emit('close', null);
    }


}
</script>

<style lang='scss'>
@import './ibizsample0021-addstepbeforewfdyna-action-view.scss';
</style>